diff -r f3e24bd4d57e trytond/modules/sale/sale.py
--- a/trytond/modules/sale/sale.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1603,214 +1397,194 @@
         depends=['active', 'salable'],
         help='In number of days')
 
-    def __init__(self):
-        super(Template, self).__init__()
-        self.account_revenue = copy.copy(self.account_revenue)
-        self.account_revenue.states = copy.copy(self.account_revenue.states)
+    @classmethod
+    def __setup__(cls):
+        super(Template, cls).__setup__()
         required = ~Eval('account_category', False) & Eval('salable', False)
-        if not self.account_revenue.states.get('required'):
-            self.account_revenue.states['required'] = required
+        if not cls.account_revenue.states.get('required'):
+            cls.account_revenue.states['required'] = required
         else:
-            self.account_revenue.states['required'] = (
-                    self.account_revenue.states['required'] | required)
-        if 'account_category' not in self.account_revenue.depends:
-            self.account_revenue = copy.copy(self.account_revenue)
-            self.account_revenue.depends = \
-                    copy.copy(self.account_revenue.depends)
-            self.account_revenue.depends.append('account_category')
-        if 'salable' not in self.account_revenue.depends:
-            self.account_revenue = copy.copy(self.account_revenue)
-            self.account_revenue.depends = \
-                    copy.copy(self.account_revenue.depends)
-            self.account_revenue.depends.append('salable')
-        self._reset_columns()
+            cls.account_revenue.states['required'] = (
+                    cls.account_revenue.states['required'] | required)
+        if 'account_category' not in cls.account_revenue.depends:
+            cls.account_revenue.depends.append('account_category')
+        if 'salable' not in cls.account_revenue.depends:
+            cls.account_revenue.depends.append('salable')
 
-    def default_salable(self):
+    @staticmethod
+    def default_salable():
         return True if Transaction().context.get('salable') else False
 
-    def default_delivery_time(self):
+    @staticmethod
+    def default_delivery_time():
         return 0
 
-    def on_change_with_sale_uom(self, vals):
-        uom_obj = Pool().get('product.uom')
-        res = None
+    def on_change_with_sale_uom(self):
+        if self.default_uom:
+            if self.sale_uom:
+                if self.default_uom.category == self.sale_uom.category:
+                    return self.sale_uom.id
+                else:
+                    return self.default_uom.id
+            else:
+                return self.default_uom.id
 
-        if vals.get('default_uom'):
-            default_uom = uom_obj.browse(vals['default_uom'])
-            if vals.get('sale_uom'):
-                sale_uom = uom_obj.browse(vals['sale_uom'])
-                if default_uom.category.id == sale_uom.category.id:
-                    res = sale_uom.id
-                else:
-                    res = default_uom.id
-            else:
-                res = default_uom.id
-        return res
 
-Template()
+class Product:
+    __name__ = 'product.product'
 
-
-class Product(ModelSQL, ModelView):
-    _name = 'product.product'
-
-    def get_sale_price(self, ids, quantity=0):
+    @staticmethod
+    def get_sale_price(products, quantity=0):
         '''
-        Return the sale price for product ids.
-
-        :param ids: the product ids
-        :param quantity: the quantity of the products
+        Return the sale price for products and quantity.
+        It uses if exists from the context:
             uom: the unit of measure
             currency: the currency id for the returned price
-        :return: a dictionary with for each product ids keys the computed price
         '''
         pool = Pool()
-        uom_obj = pool.get('product.uom')
-        user_obj = pool.get('res.user')
-        currency_obj = pool.get('currency.currency')
-        date_obj = pool.get('ir.date')
+        Uom = pool.get('product.uom')
+        User = pool.get('res.user')
+        Currency = pool.get('currency.currency')
+        Date = pool.get('ir.date')
 
-        today = date_obj.today()
-        res = {}
+        today = Date.today()
+        prices = {}
 
         uom = None
         if Transaction().context.get('uom'):
-            uom = uom_obj.browse(Transaction().context.get('uom'))
+            uom = Uom(Transaction().context.get('uom'))
 
         currency = None
         if Transaction().context.get('currency'):
-            currency = currency_obj.browse(
-                    Transaction().context.get('currency'))
+            currency = Currency(Transaction().context.get('currency'))
 
-        user2 = user_obj.browse(Transaction().user)
+        user = User(Transaction().user)
 
-        for product in self.browse(ids):
-            res[product.id] = product.list_price
+        for product in products:
+            prices[product.id] = product.list_price
             if uom:
-                res[product.id] = uom_obj.compute_price(
-                        product.default_uom, res[product.id], uom)
-            if currency and user2.company:
-                if user2.company.currency.id != currency.id:
+                prices[product.id] = Uom.compute_price(
+                    product.default_uom, prices[product.id], uom)
+            if currency and user.company:
+                if user.company.currency != currency:
                     date = Transaction().context.get('sale_date') or today
                     with Transaction().set_context(date=date):
-                        res[product.id] = currency_obj.compute(
-                                user2.company.currency.id, res[product.id],
-                                currency.id, round=False)
-        return res
+                        prices[product.id] = Currency.compute(
+                            user.company.currency, prices[product.id],
+                            currency, round=False)
+        return prices
 
-    def compute_delivery_date(self, product, date=None):
+    def compute_delivery_date(self, date=None):
         '''
-        Compute the delivery date for the Product at a the given date
+        Compute the delivery date a the given date
         '''
-        date_obj = Pool().get('ir.date')
+        Date = Pool().get('ir.date')
 
         if not date:
-            date = date_obj.today()
-        return date + datetime.timedelta(product.delivery_time)
+            date = Date.today()
+        return date + datetime.timedelta(self.delivery_time)
 
-Product()
 
+class ShipmentOut:
+    __name__ = 'stock.shipment.out'
 
-class ShipmentOut(ModelSQL, ModelView):
-    _name = 'stock.shipment.out'
-
-    def __init__(self):
-        super(ShipmentOut, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentOut, cls).__setup__()
+        cls._error_messages.update({
                 'reset_move': 'You cannot reset to draft a move generated '
                     'by a sale.',
             })
 
-    def write(self, ids, vals):
-        sale_obj = Pool().get('sale.sale')
-        sale_line_obj = Pool().get('sale.line')
+    @classmethod
+    def write(cls, shipments, vals):
+        pool = Pool()
+        Sale = pool.get('sale.sale')
+        SaleLine = pool.get('sale.line')
 
-        res = super(ShipmentOut, self).write(ids, vals)
+        super(ShipmentOut, cls).write(shipments, vals)
 
         if 'state' in vals and vals['state'] in ('done', 'cancel'):
-            sale_ids = []
+            sales = []
             move_ids = []
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-            for shipment in self.browse(ids):
+            for shipment in shipments:
                 move_ids.extend([x.id for x in shipment.outgoing_moves])
 
-            sale_line_ids = sale_line_obj.search([
-                ('moves', 'in', move_ids),
-                ])
-            if sale_line_ids:
-                for sale_line in sale_line_obj.browse(sale_line_ids):
-                    if sale_line.sale.id not in sale_ids:
-                        sale_ids.append(sale_line.sale.id)
+            sale_lines = SaleLine.search([
+                    ('moves', 'in', move_ids),
+                    ])
+            if sale_lines:
+                for sale_line in sale_lines:
+                    if sale_line.sale not in sales:
+                        sales.append(sale_line.sale)
 
             with Transaction().set_user(0, set_context=True):
-                sale_obj.process(sale_ids)
-        return res
+                sales = Sale.browse([s.id for s in sales])
+            Sale.process(sales)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        for shipment in self.browse(ids):
+    def draft(cls, shipments):
+        for shipment in shipments:
             for move in shipment.outgoing_moves:
                 if move.state == 'cancel' and move.sale_line:
-                    self.raise_user_error('reset_move')
+                    cls.raise_user_error('reset_move')
 
-        return super(ShipmentOut, self).draft(ids)
+        return super(ShipmentOut, cls).draft(shipments)
 
-ShipmentOut()
 
+class ShipmentOutReturn:
+    __name__ = 'stock.shipment.out.return'
 
-class ShipmentOutReturn(ModelSQL, ModelView):
-    _name = 'stock.shipment.out.return'
-
-    def __init__(self):
-        super(ShipmentOutReturn, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentOutReturn, cls).__setup__()
+        cls._error_messages.update({
                 'reset_move': 'You cannot reset to draft a move generated '
                     'by a sale.',
             })
 
-    def write(self, ids, vals):
-        sale_obj = Pool().get('sale.sale')
-        sale_line_obj = Pool().get('sale.line')
+    @classmethod
+    def write(cls, shipments, vals):
+        pool = Pool()
+        Sale = pool.get('sale.sale')
+        SaleLine = pool.get('sale.line')
 
-        res = super(ShipmentOutReturn, self).write(ids, vals)
+        super(ShipmentOutReturn, cls).write(shipments, vals)
 
         if 'state' in vals and vals['state'] == 'received':
-            sale_ids = []
+            sales = []
             move_ids = []
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-            for shipment in self.browse(ids):
+            for shipment in shipments:
                 move_ids.extend([x.id for x in shipment.incoming_moves])
 
-            sale_line_ids = sale_line_obj.search([
-                ('moves', 'in', move_ids),
-                ])
-            if sale_line_ids:
-                for sale_line in sale_line_obj.browse(sale_line_ids):
-                    if sale_line.sale.id not in sale_ids:
-                        sale_ids.append(sale_line.sale.id)
+            sale_lines = SaleLine.search([
+                    ('moves', 'in', move_ids),
+                    ])
+            if sale_lines:
+                for sale_line in sale_lines:
+                    if sale_line.sale not in sales:
+                        sales.append(sale_line.sale)
 
             with Transaction().set_user(0, set_context=True):
-                sale_obj.process(sale_ids)
-        return res
+                sales = Sale.browse([s.id for s in sales])
+            Sale.process(sales)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        for shipment in self.browse(ids):
+    def draft(cls, shipments):
+        for shipment in shipments:
             for move in shipment.incoming_moves:
                 if move.state == 'cancel' and move.sale_line:
-                    self.raise_user_error('reset_move')
+                    cls.raise_user_error('reset_move')
 
-        return super(ShipmentOutReturn, self).draft(ids)
+        return super(ShipmentOutReturn, cls).draft(shipments)
 
-ShipmentOutReturn()
 
-
-class Move(ModelSQL, ModelView):
-    _name = 'stock.move'
-
+class Move:
+    __name__ = 'stock.move'
     sale_line = fields.Many2One('sale.line', 'Sale Line', select=True,
         states={
             'readonly': Eval('state') != 'draft',
@@ -1824,197 +1598,118 @@
         ('recreated', 'Recreated'),
         ], 'Exception State'), 'get_sale_exception_state')
 
-    def get_sale(self, ids, name):
-        res = {}
-        for move in self.browse(ids):
-            res[move.id] = None
-            if move.sale_line:
-                res[move.id] = move.sale_line.sale.id
-        return res
+    def get_sale(self, name):
+        if self.sale_line:
+            return self.sale_line.sale.id
 
-    def search_sale(self, name, clause):
+    @classmethod
+    def search_sale(cls, name, clause):
         return [('sale_line.' + name,) + clause[1:]]
 
-    def get_sale_exception_state(self, ids, name):
-        res = {}.fromkeys(ids, '')
-        for move in self.browse(ids):
-            if not move.sale_line:
-                continue
-            if move.id in (x.id for x in move.sale_line.moves_recreated):
-                res[move.id] = 'recreated'
-            if move.id in (x.id for x in move.sale_line.moves_ignored):
-                res[move.id] = 'ignored'
-        return res
+    def get_sale_exception_state(self, name):
+        if not self.sale_line:
+            return ''
+        if self in self.sale_line.moves_recreated:
+            return 'recreated'
+        if self in self.sale_line.moves_ignored:
+            return 'ignored'
+        return ''
 
-    def write(self, ids, vals):
-        sale_obj = Pool().get('sale.sale')
-        sale_line_obj = Pool().get('sale.line')
+    @classmethod
+    def write(cls, moves, vals):
+        pool = Pool()
+        Sale = pool.get('sale.sale')
+        SaleLine = pool.get('sale.line')
 
-        res = super(Move, self).write(ids, vals)
+        super(Move, cls).write(moves, vals)
         if 'state' in vals and vals['state'] in ('cancel',):
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-            sale_ids = set()
-            sale_line_ids = sale_line_obj.search([
-                ('moves', 'in', ids),
+            sales = set()
+            sale_lines = SaleLine.search([
+                    ('moves', 'in', [m.id for m in moves]),
+                    ])
+            if sale_lines:
+                for sale_line in sale_lines:
+                    sales.add(sale_line.sale)
+            if sales:
+                with Transaction().set_user(0, set_context=True):
+                    sales = Sale.browse([s.id for s in sales])
+                Sale.process(sales)
+
+    @classmethod
+    def delete(cls, moves):
+        pool = Pool()
+        Sale = pool.get('sale.sale')
+        SaleLine = pool.get('sale.line')
+
+        sales = set()
+        sale_lines = SaleLine.search([
+                ('moves', 'in', [m.id for m in moves]),
                 ])
-            if sale_line_ids:
-                for sale_line in sale_line_obj.browse(sale_line_ids):
-                    sale_ids.add(sale_line.sale.id)
-            if sale_ids:
+
+        super(Move, cls).delete(moves)
+
+        if sale_lines:
+            for sale_line in sale_lines:
+                sales.add(sale_line.sale)
+            if sales:
                 with Transaction().set_user(0, set_context=True):
-                    sale_obj.process(list(sale_ids))
-        return res
-
-    def delete(self, ids):
-        sale_obj = Pool().get('sale.sale')
-        sale_line_obj = Pool().get('sale.line')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        sale_ids = set()
-        sale_line_ids = sale_line_obj.search([
-            ('moves', 'in', ids),
-            ])
-
-        res = super(Move, self).delete(ids)
-
-        if sale_line_ids:
-            for sale_line in sale_line_obj.browse(sale_line_ids):
-                sale_ids.add(sale_line.sale.id)
-            if sale_ids:
-                with Transaction().set_user(0, set_context=True):
-                    sale_obj.process(list(sale_ids))
-        return res
-
-Move()
-
-
-class Invoice(ModelSQL, ModelView):
-    _name = 'account.invoice'
-
-    sale_exception_state = fields.Function(fields.Selection([
-        ('', ''),
-        ('ignored', 'Ignored'),
-        ('recreated', 'Recreated'),
-        ], 'Exception State'), 'get_sale_exception_state')
-
-    def __init__(self):
-        super(Invoice, self).__init__()
-        self._error_messages.update({
-            'delete_sale_invoice': 'You can not delete invoices '
-                    'that come from a sale!',
-            'reset_invoice_sale': 'You cannot reset to draft '
-                    'an invoice generated by a sale.',
-            })
-
-    @Workflow.transition('draft')
-    def draft(self, ids):
-        sale_obj = Pool().get('sale.sale')
-        sale_ids = sale_obj.search([
-            ('invoices', 'in', ids),
-            ])
-
-        if sale_ids:
-            self.raise_user_error('reset_invoice_sale')
-
-        return super(Invoice, self).draft(ids)
-
-    def get_sale_exception_state(self, ids, name):
-        sale_obj = Pool().get('sale.sale')
-        sale_ids = sale_obj.search([
-            ('invoices', 'in', ids),
-            ])
-
-        sales = sale_obj.browse(sale_ids)
-
-        recreated_ids = tuple(i.id for p in sales
-            for i in p.invoices_recreated)
-        ignored_ids = tuple(i.id for p in sales for i in p.invoices_ignored)
-
-        res = {}.fromkeys(ids, '')
-        for invoice in self.browse(ids):
-            if invoice.id in recreated_ids:
-                res[invoice.id] = 'recreated'
-            elif invoice.id in ignored_ids:
-                res[invoice.id] = 'ignored'
-
-        return res
-
-    def delete(self, ids):
-        if not ids:
-            return True
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        Transaction().cursor.execute('SELECT id FROM sale_invoices_rel '
-                'WHERE invoice IN (' + ','.join(('%s',) * len(ids)) + ')',
-                ids)
-        if Transaction().cursor.fetchone():
-            self.raise_user_error('delete_sale_invoice')
-        return super(Invoice, self).delete(ids)
-
-Invoice()
+                    sales = Sale.browse([s.id for s in sales])
+                Sale.process(list(sales))
 
 
 class OpenCustomer(Wizard):
     'Open Customers'
-    _name = 'sale.open_customer'
+    __name__ = 'sale.open_customer'
     start_state = 'open_'
     open_ = StateAction('party.act_party_form')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         pool = Pool()
-        model_data_obj = pool.get('ir.model.data')
-        wizard_obj = pool.get('ir.action.wizard')
-        Transaction().cursor.execute("SELECT DISTINCT(party) FROM sale_sale")
+        ModelData = pool.get('ir.model.data')
+        Wizard = pool.get('ir.action.wizard')
+        cursor = Transaction().cursor
+        cursor.execute("SELECT DISTINCT(party) FROM sale_sale")
         customer_ids = [line[0] for line in Transaction().cursor.fetchall()]
         action['pyson_domain'] = PYSONEncoder().encode(
             [('id', 'in', customer_ids)])
 
-        model_data_ids = model_data_obj.search([
-            ('fs_id', '=', 'act_open_customer'),
-            ('module', '=', 'sale'),
-            ('inherit', '=', None),
-            ], limit=1)
-        model_data = model_data_obj.browse(model_data_ids[0])
-        wizard = wizard_obj.browse(model_data.db_id)
+        model_data, = ModelData.search([
+                ('fs_id', '=', 'act_open_customer'),
+                ('module', '=', 'sale'),
+                ('inherit', '=', None),
+                ], limit=1)
+        wizard = Wizard.browse(model_data.db_id)
 
         action['name'] = wizard.name
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenCustomer()
-
 
 class HandleShipmentExceptionAsk(ModelView):
     'Handle Shipment Exception'
-    _name = 'sale.handle.shipment.exception.ask'
-    _description = __doc__
-
+    __name__ = 'sale.handle.shipment.exception.ask'
     recreate_moves = fields.Many2Many(
         'stock.move', None, None, 'Recreate Moves',
         domain=[('id', 'in', Eval('domain_moves'))], depends=['domain_moves'])
     domain_moves = fields.Many2Many(
         'stock.move', None, None, 'Domain Moves')
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model "
                 "SET model = REPLACE(model, 'packing', 'shipment') "
                 "WHERE model like '%%packing%%' AND module = %s",
                 (module_name,))
-        super(HandleShipmentExceptionAsk, self).init(module_name)
-
-HandleShipmentExceptionAsk()
+        super(HandleShipmentExceptionAsk, cls).__register__(module_name)
 
 
 class HandleShipmentException(Wizard):
     'Handle Shipment Exception'
-    _name = 'sale.handle.shipment.exception'
+    __name__ = 'sale.handle.shipment.exception'
     start_state = 'ask'
     ask = StateView('sale.handle.shipment.exception.ask',
         'sale.handle_shipment_exception_ask_view_form', [
@@ -2023,59 +1718,53 @@
             ])
     handle = StateTransition()
 
-    def default_ask(self, session, fields):
-        sale_obj = Pool().get('sale.sale')
-        sale = sale_obj.browse(Transaction().context.get('active_id'))
+    def default_ask(self, fields):
+        Sale = Pool().get('sale.sale')
+        sale = Sale(Transaction().context.get('active_id'))
 
         moves = []
         for line in sale.lines:
-            skip_ids = set(x.id for x in line.moves_ignored)
-            skip_ids.update(x.id for x in line.moves_recreated)
+            skips = set(line.moves_ignored)
+            skips.update(line.moves_recreated)
             for move in line.moves:
-                if move.state == 'cancel' and move.id not in skip_ids:
+                if move.state == 'cancel' and move not in skips:
                     moves.append(move.id)
         return {
             'recreate_moves': moves,
             'domain_moves': moves,
             }
 
-    def transition_handle(self, session):
+    def transition_handle(self):
         pool = Pool()
-        sale_obj = pool.get('sale.sale')
-        sale_line_obj = pool.get('sale.line')
-        to_recreate = [x.id for x in session.ask.recreate_moves]
-        domain_moves = [x.id for x in session.ask.domain_moves]
+        Sale = pool.get('sale.sale')
+        SaleLine = pool.get('sale.line')
 
-        sale = sale_obj.browse(Transaction().context['active_id'])
+        sale = Sale(Transaction().context['active_id'])
 
         for line in sale.lines:
             moves_ignored = []
             moves_recreated = []
-            skip_ids = set(x.id for x in line.moves_ignored)
-            skip_ids.update(x.id for x in line.moves_recreated)
+            skips = set(line.moves_ignored)
+            skips.update(line.moves_recreated)
             for move in line.moves:
-                if move.id not in domain_moves or move.id in skip_ids:
+                if move not in self.ask.domain_moves or move in skips:
                     continue
-                if move.id in to_recreate:
+                if move in self.ask.recreate_moves:
                     moves_recreated.append(move.id)
                 else:
                     moves_ignored.append(move.id)
 
-            sale_line_obj.write(line.id, {
+            SaleLine.write([line], {
                     'moves_ignored': [('add', moves_ignored)],
                     'moves_recreated': [('add', moves_recreated)],
                     })
-        sale_obj.process([sale.id])
+        Sale.process([sale])
         return 'end'
 
-HandleShipmentException()
-
 
 class HandleInvoiceExceptionAsk(ModelView):
     'Handle Invoice Exception'
-    _name = 'sale.handle.invoice.exception.ask'
-    _description = __doc__
-
+    __name__ = 'sale.handle.invoice.exception.ask'
     recreate_invoices = fields.Many2Many(
         'account.invoice', None, None, 'Recreate Invoices',
         domain=[('id', 'in', Eval('domain_invoices'))],
@@ -2085,12 +1774,10 @@
     domain_invoices = fields.Many2Many(
         'account.invoice', None, None, 'Domain Invoices')
 
-HandleInvoiceExceptionAsk()
-
 
 class HandleInvoiceException(Wizard):
     'Handle Invoice Exception'
-    _name = 'sale.handle.invoice.exception'
+    __name__ = 'sale.handle.invoice.exception'
     start_state = 'ask'
     ask = StateView('sale.handle.invoice.exception.ask',
         'sale.handle_invoice_exception_ask_view_form', [
@@ -2099,65 +1786,57 @@
             ])
     handle = StateTransition()
 
-    def default_ask(self, session, fields):
-        sale_obj = Pool().get('sale.sale')
+    def default_ask(self, fields):
+        Sale = Pool().get('sale.sale')
 
-        sale = sale_obj.browse(Transaction().context['active_id'])
-        skip_ids = set(x.id for x in sale.invoices_ignored)
-        skip_ids.update(x.id for x in sale.invoices_recreated)
+        sale = Sale(Transaction().context['active_id'])
+        skips = set(sale.invoices_ignored)
+        skips.update(sale.invoices_recreated)
         invoices = []
         for invoice in sale.invoices:
-            if invoice.state == 'cancel' and invoice.id not in skip_ids:
+            if invoice.state == 'cancel' and invoice not in skips:
                 invoices.append(invoice.id)
         return {
             'recreate_invoices': invoices,
             'domain_invoices': invoices,
             }
 
-    def transition_handle(self, session):
-        sale_obj = Pool().get('sale.sale')
-        to_recreate = [x.id for x in session.ask.recreate_invoices]
-        domain_invoices = [x.id for x in session.ask.domain_invoices]
+    def transition_handle(self):
+        Sale = Pool().get('sale.sale')
 
-        sale = sale_obj.browse(Transaction().context['active_id'])
+        sale = Sale(Transaction().context['active_id'])
 
-        skip_ids = set(x.id for x in sale.invoices_ignored)
-        skip_ids.update(x.id for x in sale.invoices_recreated)
+        skips = set(sale.invoices_ignored)
+        skips.update(sale.invoices_recreated)
         invoices_ignored = []
         invoices_recreated = []
         for invoice in sale.invoices:
-            if invoice.id not in domain_invoices or invoice.id in skip_ids:
+            if invoice not in self.ask.domain_invoices or invoice in skips:
                 continue
-            if invoice.id in to_recreate:
+            if invoice in self.ask.recreate_invoices:
                 invoices_recreated.append(invoice.id)
             else:
                 invoices_ignored.append(invoice.id)
 
-        sale_obj.write(sale.id, {
+        Sale.write([sale], {
                 'invoices_ignored': [('add', invoices_ignored)],
                 'invoices_recreated': [('add', invoices_recreated)],
                 })
-        sale_obj.process([sale.id])
+        Sale.process([sale])
         return 'end'
 
-HandleInvoiceException()
-
 
 class ReturnSale(Wizard):
-    _name = 'sale.return_sale'
+    __name__ = 'sale.return_sale'
     start_state = 'make_return'
     make_return = StateTransition()
 
-    def transition_make_return(self, session):
-        pool = Pool()
-        sale_obj = pool.get('sale.sale')
-        line_obj = pool.get('sale.line')
+    def transition_make_return(self):
+        Sale = Pool().get('sale.sale')
 
-        sale_id = Transaction().context['active_id']
-        new_sale_id = sale_obj.copy(sale_id)
-        new_line_ids = line_obj.search([('sale', '=', new_sale_id)])
-        for new_line in line_obj.browse(new_line_ids):
-            line_obj.write(new_line.id, {'quantity': -new_line.quantity})
+        sale = Sale(Transaction().context['active_id'])
+        new_sale, = Sale.copy([sale])
+        for new_line in new_sale.lines:
+            new_line.quantity *= -1
+            new_line.save()
         return 'end'
-
-ReturnSale()
diff -r e3c518c64971 trytond/modules/sale_opportunity/__init__.py
--- a/trytond/modules/sale_opportunity/__init__.py	Sun Sep 23 16:25:47 2012 +0200
+++ b/trytond/modules/sale_opportunity/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,4 +1,20 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .opportunity import *
+
+
+def register():
+    Pool.register(
+        SaleOpportunity,
+        SaleOpportunityLine,
+        SaleOpportunityHistory,
+        SaleOpportunityEmployee,
+        OpenSaleOpportunityEmployeeStart,
+        SaleOpportunityMonthly,
+        SaleOpportunityEmployeeMonthly,
+        module='sale_opportunity', type_='model')
+    Pool.register(
+        OpenSaleOpportunityEmployee,
+        module='sale_opportunity', type_='wizard')
